#!/usr/bin/env node
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const dotenv_1 = __importDefault(require("dotenv"));
const Leetcode = __importStar(require("./leetcode"));
const Problem = __importStar(require("./problem"));
const path_1 = __importDefault(require("path"));
async function addProblemProgram(program) {
    const makeProblemCommand = (name) => {
        const newAction = async (slug, dst) => {
            try {
                await Problem.New(slug, dst);
            }
            catch (err) {
                console.log(err);
            }
        };
        const pullAction = async (slug, dst) => {
            try {
                if (!slug) {
                    slug = process.env.INIT_CWD?.split(path_1.default.sep).slice(-1)[0];
                    slug = slug.split(".").slice(-1)[0];
                }
                if (!dst) {
                    dst = process.env.INIT_CWD;
                }
                await Problem.Pull(slug, dst);
            }
            catch (err) {
                console.log(err);
            }
        };
        const subProgram = program.command(name);
        subProgram.description("some operations related to the problem");
        subProgram.command("new <slug> [dst]").action(newAction);
        subProgram.command("pull [slug] [dst]").action(pullAction);
    };
    makeProblemCommand("problem");
    makeProblemCommand("p");
}
(async () => {
    dotenv_1.default.config();
    await Leetcode.Login();
    const program = new commander_1.Command();
    program.description("A cli tool to enjoy leetcode!");
    addProblemProgram(program);
    program.parse(process.argv);
})();
//# sourceMappingURL=index.js.map